function Ret = priv_isorthogonalmatrix( x)
%ISORTHONORMAL  check if matrix x is orthogonal
%
%  Ret = isorthogonalmatrix( x)
%
% U orthogonal <=> U * transpose(U) = 1
%
% Note: U need not be unitary!

% (c) 2013 G. Beyerle

  [nrow, ncol] = size( x);

  if nrow ~= ncol,
    error( [upper( mfilename) ': matrix not square!'])
  end
  
  Delta = x * transpose( x) - eye( nrow);

  if max( max( abs( Delta))) < 100*eps;
    Ret = true;  
  else
    disp( [upper( mfilename) ': max( Delta(:)) = ' ...
      num2str( max( Delta(:)))])
    Ret = false;  
  end
  
end
