function Ret = priv_isskewsymmetricmatrix( x, MaxEps)
%ISSKEWSYMMETRICMATRIX  check if matrix x is skew-symmetric
%
%  Ret = issymmetric( x)

% (c) 2013 G. Beyerle

  if nargin < 2,
    MaxEps = 100 * eps;
  end

  Delta = x + transpose( x);

  if max( max( abs( Delta))) < MaxEps;
    Ret = true;  
  else
    disp( [ upper( mfilename) ': delta = ' ...
      num2str( max( max( abs( Delta))))])
    Ret = false;  
  end
  
end
