function priv_testadjointrepresentation( Rank, StructConst, AdjRep)
%PRIV_TESTADJOINTREPRESENTATION   test adjoint representation
%
%    priv_testadjointrepresentation( StructConst, AdjRep)
%
%  test that
%
%    [AdjRep_i,AdjRep_j] = StructConst^k_ij * AdjRep_k
%  
%  is true.

% (c) G. Beyerle 2012

  priv_assert( all( size( StructConst) == size( AdjRep)))

  N = size( StructConst, 1);

%   KillingForm = zeros( N, N);
% 
%   for i = 1:N,
%     for j = 1:N,
% %      diag( AdjRep(:,:,i) * AdjRep(:,:,j))'
%       KillingForm(i,j) = trace( AdjRep(:,:,i) * AdjRep(:,:,j));
%     end
%   end
  
%   disp('KillingForm = ')
%   KillingForm
%   disp('(alpha_i,alpha_j) = ')
%   RootXRoot((1:Rank)+NofPosRoots,(1:Rank)+NofPosRoots);
%  keyboard
  
%   for i = 1:NofRoots+Rank,
%     disp( ['ad h_ ' num2str( i) ' = '])
%     disp( AdjRep(:,:,i))
%   end
%   keyboard
  
  TestFailed = 0;
  
  if 1,  

%    disp( [ upper( mfilename) ': compare calculated / expected entries ...'])
    for i = 1:N,

      disp( ['i = ' num2str(i) ' / ' num2str( N)])
      for j = 1:N,

  %
  %  commutator
  %
%         Tmp1 = squeeze( StructConst(i,:,:))' * squeeze( StructConst(j,:,:))' - ...
%                squeeze( StructConst(j,:,:))' * squeeze( StructConst(i,:,:))'; 
             
        Tmp1 = AdjRep(:,:,i) * AdjRep(:,:,j) - AdjRep(:,:,j) * AdjRep(:,:,i);

%
%  check that the relation
%
%    [AdjRep(:,:,i), AdjRep(:,:,j)] = SUM_k StructConst(i,j,k) * AdjRep(:,:,k)
%
%  is true.
%
        Tmp2 = zeros( N, N);     
        NofSum = 0; 
        
        kIdx = find( StructConst(i,j,:))';
        if ~isempty( kIdx)
          for k = kIdx,
            NofSum = NofSum + 1; 
            Tmp2 = Tmp2 + StructConst(i,j,k) * AdjRep(:,:,k);
          end
        end
                
%         for k = 1:N,
%           if StructConst(i,j,k)
%             NofSum = NofSum + 1; 
%             Tmp2 = Tmp2 + StructConst(i,j,k) * AdjRep(:,:,k);
%           end
% %          Tmp2 = Tmp2 + StructConst(i,j,k) * squeeze( StructConst(k,:,:))';
%         end
        
% check number of terms in sum        
        if ( NofSum > Rank)
          disp( ['i = ' num2str( i) ', j = ' num2str( j)])
          StructConst(i,j,:)
          keyboard
        end
        
        if any( any( Tmp1 ~= Tmp2))

          if 0,
            disp( [ upper( mfilename) ': expected  [X_' num2str(i) ', X_' ...
              num2str(j) '] = X_' num2str(k)])
            disp( [ upper( mfilename) ': X_' num2str(k) ' ='])
            if all( all( Tmp1 == 0))
              disp( 0)
            else
              disp( Tmp1)    
            end
            
            disp( [ upper( mfilename) ...
              ': but calculation from AdjRep yields [X_' num2str(i) ', X_' num2str(j) '] ='])
            if all( all( Tmp2 == 0))
              disp( 0)
            else
              disp( Tmp2)    
            end
  %           disp( [ upper( mfilename) ': StructConst(' ...
  %             num2str(i) ',' num2str(j) ',' num2str(k) ') = ' num2str( StructConst(i,i,k))])
          end
          
          [iSel,jSel] = find( Tmp1 ~= Tmp2);
          for k = 1:length( iSel),
            disp( [ sprintf( 'i=%2d, j=%2d', i, j) ...
              ' -> Tmp(' sprintf( '%2d,%2d', iSel(k), jSel(k)) ') : ' ...
              sprintf( '%2d != %2d ',  Tmp1(iSel(k),jSel(k)), Tmp2(iSel(k),jSel(k)))])
          end
          TestFailed = 1;
%          keyboard
        end

      end
    end

  end
  
  if ~TestFailed
    disp( [ upper( mfilename) ': ... test adjoint representation passed.'])
  else
    disp( [ upper( mfilename) ': *** test adjoint representation failed! ***'])
  end
  
  return
    
end

% % -------------------------------------------------------------------------
% %
% %  compare equality of two generators
% %
% function local_comparegenerators( Tmp1, Tmp2, i, j, k)
% 
%   if ~any( any( Tmp1 ~= Tmp2))
%     return
%   end
%  
%   disp( [ upper( mfilename) ': expected  [X_' num2str(i) ', X_' ...
%     num2str(j) '] = X_' num2str(k)])
%   disp( [ upper( mfilename) ': X_' num2str(k) ' ='])
%   disp( Tmp2)    
%   disp( [ upper( mfilename) ': but found [X_' num2str(i) ', X_' num2str(j) '] ='])
%   disp( Tmp1)    
%   keyboard
% 
% end
% 
% function local_validateCartanGenerator( Tmp, ZeroGenerator)
% 
%   NofGen = size( ZeroGenerator, 1);
%   for i = 1:NofGen
%     disp( [ upper( mfilename) ': H_' num2str(i) ' ='])
%     disp( squeeze( ZeroGenerator(i,:,:))')
%   end
%   Tmp
%   keyboard
%   
% end
