function priv_validatewybournetheorem81( metric, NCoeff)
%PRIV_VALIDATEWYBOURNETHEOREM81   check Theorem 8.1 in Wybourne
%
%  priv_validatewybournetheorem81( metric, NCoeff)
%

% (c) G. Beyerle 2012

  global ROOTS
  global SUMOFROOTS
  global ROOTFLIPSIGN
  
  nofRoots = size( ROOTS, 2);

  for i = 1:nofRoots,
    for j = 1:nofRoots,
      for k = 1:nofRoots,
  
        iPj = SUMOFROOTS( i, j);
        
        if iPj == 0,
          continue
        end
          
        if iPj ~= ROOTFLIPSIGN(k)
          continue
        end
           
        aa     = (ROOTS(:,i)' * metric * ROOTS(:,i));
        bb     = (ROOTS(:,j)' * metric * ROOTS(:,j));
        aPbaPb = (ROOTS(:,iPj)' * metric * ROOTS(:,iPj));
        
        if NCoeff(j,k) / NCoeff(k,i) == aa / bb && ...
           NCoeff(k,i) / NCoeff(i,j) == bb / aPbaPb
         continue
        end
        
        if NCoeff(j,k) == aa / bb * NCoeff(k,i) && ...
           NCoeff(k,i) == bb / aPbaPb * NCoeff(i,j)
         continue
        end

        NCoeff(j,k)
        NCoeff(k,i)
        NCoeff(i,j)
        
        (ROOTS(:,i)' * metric * ROOTS(:,i)) 
        (ROOTS(:,j)' * metric * ROOTS(:,j))
        (ROOTS(:,iPj)' * metric * ROOTS(:,iPj))
        
        disp( sprintf( 'i  = %2d, j  = %2d, k  = %2d', i, j, k))

%        i,j,k
        keyboard

      end
    end
  end

  disp( [upper( mfilename) ': Theorem 8.1 fulfilled!'])
  
end
