function AdjRepTrans = priv_transformadjrep( rank, AdjRep, type)
%PRIV_TRANSFORMADJREP  transform matrices of adj repentation
%
% AdjRepTrans = priv_transformadjrep( rank, AdjRep)
%

%  StructConst = permute( AdjRep, [3 2 1]);

% (c) G. Beyerle 2012

  N = size( AdjRep, 1);

  NofRoots    = N - rank;
  NofPosRoots = NofRoots / 2;

%
%  G : transformation matrix
%  between V+,V- and Vx,Vy
%
%    V+ = Vx + 1i * Vy
%    V- = Vx - 1i * Vy
%
  G = zeros( N, N);
    
  Sel = (1:NofPosRoots);
  for i = Sel,
    G(i,i)                           = -1i;
    G(i+NofPosRoots,NofPosRoots+1-i) = +1i;
  end
  
  Sel = (NofPosRoots+1:NofRoots);
  for i = Sel,
    G(i,i)            = 1;
    G(NofRoots+1-i,i) = 1;
  end
   
%
%  generators belonging to zero root
%
  Sel = (NofRoots+1:N);
% 
  for i = Sel,
    G(i,i) = 1;
  end
%   G(7,7) = 2;
%   G(7,8) = 1;
%   G(8,7) = -1;
%   G(8,8) = 2;
%   disp('*** G(i,j) = ...; ***');

%   switch [upper(type) num2str(rank)]
%     case 'A2'
%       disp('*** G(i,j) = ...; ***');
%     %   G(7,:) = 1;
%     %   G(8,:) = 1;
%     %   G(:,7) = 1;
%     %   G(:,8) = 1;
%       X =  [1.150787012178977   0.493132098344008   0.094987291829560   1.044104432912420];
% %       G(7,7) = XXX(1);
% %       G(8,7) = XXX(2);
% %       G(7,8) = XXX(3);
% %       G(8,8) = XXX(4);
%       disp('*** testing!!! ***')
% 
%     case 'A3'
%       X = ...
%       [ 1.011172934711361   0.102280873503401  -0.010981853370884;
%        0.209528961833627   1.063974615658731   0.121859961211610;
%       -0.090476408292566   0.344343859609862   1.166600796280490];
% 
%     case 'G2'
%       X = ...
%       [ 0.619072831762263   1.927991731401703
%        -0.259255054023513   1.177768308933783   ]; 
%       X = eye(2);
% 
%     otherwise
%       disp( [upper(mfilename) ': not yet ...'])
%       X = eye(rank);
%   end
%   
%   G(NofRoots+1:end,NofRoots+1:end) = X;
  
%  keyboard

%   G(1,1) = 1/2 * G(1,1);
%    G(1,6) = 1/2 * G(1,6);
%    G(6,6) = 1/2 * G(6,6);
%    G(6,1) = 1/2 * G(6,1);
%   G
%   keyboard
  
  InvG = inv( G);
   
%  priv_assert( all( all( InvG * G - eye(N) == 0)))
  priv_assert( max( max( abs( InvG * G - eye(N)))) < 1e-13)
%   keyboard
   
%   G
%   InvG
%   keyboard

%   for i = Sel,
%     for j = Sel,
%       G(i,j) = 1;
% %    G(i,i) = 0;
%     end
%   end
%   
%   disp('*** G(i,j) = ...; ***');

%   G(Sel(1),Sel(1)) = 1;
%   G(Sel(2),Sel(2)) = 2;
%   for i = Sel,
%     for j = Sel,
%       G(i,j) = Roots(i-NofRoots,j-NofRoots/2);
%     end
%   end
    
  priv_assert( all( all( isfinite( InvG))))

  Tmp = zeros( size( AdjRep));
%  XTmp = zeros( size( AdjRep));
  AdjRepTrans = zeros( size( AdjRep));
%  tic
  for i = 1:N,
    Tmp(:,:,i) = InvG * squeeze( AdjRep(:,:,i)) * G;
%    XTmp(:,:,i) = squeeze( AdjRep(:,:,i)) * G;
  end
  
%    Tmp2 = InvG * sum( AdjRep, 3) * G;
%    Tmp2
%    sum( Tmp, 3)
%    sum( AdjRep, 3)
%    keyboard
  
%   ElapsedTime = toc;
%   disp( [upper( mfilename) ': timing Trans^-1 AdjRep * Trans >' ...
%     num2str( ElapsedTime) ' sec<'])

%   min( real( InvG(:)))
%   max( real( InvG(:)))
%   min( imag( InvG(:)))
%   max( imag( InvG(:)))
%   keyboard
  
%  AdjRepTrans : linear combination of inv(G) * AdjRep G

%
%  roots are sorted in this way:
%
%  index                root    
% --------------------------------
%       1             -alpha_n
%       2             -alpha_(n-1)
%           ...
%   NofPosRoots-1     -alpha_2
%   NofPosRoot        -alpha_1
%   NofPosRoots+1     +alpha_1
%   NofPosRoots+2     +alpha_2
%           ...
%   NofRoots-1        +alpha_(n-1)
%   NofRoots          +alpha_n
%
%   NofPosRoots = NofRoots/2
%
  for i = NofPosRoots+1:NofRoots,
    iMinus = NofRoots+1-i;
    AdjRepTrans(:,:,i)      = 1/2i * (Tmp(:,:,i) + Tmp(:,:,iMinus));
    AdjRepTrans(:,:,iMinus) = 1/2 * (Tmp(:,:,i) - Tmp(:,:,iMinus));
%     i
%     iMinus
%     keyboard
  end

%
%  adj. representations corresponding to zero roots
%
  for i = NofRoots+1:N,
    AdjRepTrans(:,:,i) = 1/2i * Tmp(:,:,i);
  end
  
%   XTmp
%   AdjRepTrans
%   keyboard

%   for i=1:N
%     disp(i)
%     for j=1:N
%       Str = sprintf( ' %4.1f', squeeze( AdjRepTrans(j,:,i)));
%       Str = [Str '   ' sprintf( ' %4.1f', squeeze( Tmp(j,:,i)))];
%       disp(Str)
%     end
%   end
%  AdjRep
%  Tmp
% %   StructConst
%  2 * AdjRepTrans(:,:,1:6)
%   G
%   InvG

%   if 1,
%     MiniG = [1, 0; 0, 1];
%     TmpAR = squeeze( AdjRep(:,:,1));
%     Tmp1 = inv(MiniG) * TmpAR(1:2,7:8) * MiniG;
%     Tmp2 = inv(MiniG) * TmpAR(7:8,1:2) * MiniG;
%     TmpAR
%     Tmp1
%     Tmp2
%     keyboard
%   end

  if 0
    MATFile = ['/home/gbeyerle/data/matlab/mat/plt/plot43137-' ...
      upper(type) num2str(rank) '.mat'];
    disp( MATFile)
    save( MATFile, 'AdjRep', 'G', 'rank')
    keyboard
  end
  
  if 0,
    G
    InvG
    disp( 'AdjRepTrans = ')
    2 * AdjRepTrans(:,:,1:6)
    keyboard
  end

%
%  make sure transformed matrices of adj. representation are real
%
  priv_assert( max( abs( imag( AdjRepTrans(:)))) == 0)
  
%   StructConstTrans = permute( AdjRepTrans, [3 2 1]); 
%   priv_testadjointrepresentation( rank, StructConstTrans, AdjRepTrans);
%   keyboard


%
%  plot of structure constant / adj. rep. matrices
%
  if 0,
    cm = jet(N);
    clfig(1)
    plot3(NaN,NaN,NaN)
    set(gca,'visible','off')
    hold on
    set(gca,'xlim', [1 N])
    set(gca,'ylim', [1 N])
    set(gca,'zlim', [1 N])
    for i = 1:N
      for j = 1:N
        for k = 1:N
  %        AdjRep(i,j,k)
          if AdjRep(i,j,k)
            text( k, N+1-j, N+1-i, ...
                  num2str( AdjRep(i,j,k)),'fontsize', 12, 'color', cm(k,:))
          end
  %        keyboard
        end
      end
  %    keyboard
    end
  %  AdjRep
  %  AdjRepTrans
    keyboard
  end
  
%  AdjRepTrans = Tmp;
%  AdjRepTrans = AdjRep;
%  disp('*** AdjRepTrans = Tmp ***')

  if 0,
    TestJacobiFailed = 0;
    TestAntisymFailed = 0;
    for i = 1:N,
      for j = 1:N,
        for k = 1:N,
          Tmp1 = commutator( squeeze( AdjRepTrans(:,:,i)), ...
                   commutator( squeeze( AdjRepTrans(:,:,j)), squeeze( AdjRepTrans(:,:,k)))) + ...
                 commutator( squeeze( AdjRepTrans(:,:,j)), ...
                   commutator( squeeze( AdjRepTrans(:,:,k)), squeeze( AdjRepTrans(:,:,i)))) + ...
                 commutator( squeeze( AdjRepTrans(:,:,k)), ...
                   commutator( squeeze( AdjRepTrans(:,:,i)), squeeze( AdjRepTrans(:,:,j))));
          if any(any( Tmp1))
            Tmp1
            [i j k]
            TestJacobiFailed = 1;
  %          Tmp1
  %          keyboard
          end
        end
      end
    end

    for i = 1:N,
      Tmp1 = squeeze( StructConstTrans(:,:,i)) + squeeze( StructConstTrans(:,:,i).');
      if any( any( Tmp1))
        Tmp1
        [i j k]
        TestAntisymFailed = 1;
      end
    end
     
    if TestJacobiFailed,
      disp( 'test Jacobi failed')
    else
      disp( 'test Jacobi passed')
    end
    if TestAntisymFailed,
      disp( 'test anti-symmetry failed')
    else
      disp( 'test anti-symmetry passed')
    end
    
    keyboard
  end
  
%   for i = 1:N,
%     for j = 1:N,
% %       Idx = find( AdjRep(i,j,:));
% %       if length(Idx)>1
% %         [i,j]
% %         AdjRep
% %         keyboard
% %       end
%       Idx = find( AdjRepTrans(i,j,:));
%       if length(Idx)>1
%         [i,j]
%         2*AdjRepTrans
%         keyboard
%       end
%     end
%   end

%   InvG
%   disp( 'AdjRep(:,:,1)')
%   AdjRep(:,:,1)
%   G
%   
%   disp( 'InvG * AdjRep(:,:,1) * G')
%   2 * InvG * AdjRep(:,:,1) * G
%   disp( 'InvG * AdjRep(:,:,6) * G')
%   2 * InvG * AdjRep(:,:,6) * G
%   
% %  2*sum( AdjRepTrans, 3)
%   keyboard
  
%  AdjRepTrans = AdjRepTrans * 2;
%  AdjRepTrans = permute( AdjRepTrans, [2 1 3]);
  
%   StructConst
%   keyboard

%   AdjRepTrans
% 
%   for i = 1:N,
%    for j = 1:N,
%      [i,j]
%      Tmp1 = commutator( squeeze( AdjRepTrans(:,:,i)), squeeze( AdjRepTrans(:,:,j)));
% %      Tmp2 = zeros( N, N);
% %      for k = 1:N,
% %        Tmp2 = Tmp2 + StructConst(i,j,k) * squeeze( AdjRepTrans(:,:,k));
% %      end
% %      Tmp1
% %      Tmp2
%      Tmp1
%      keyboard
%    end
%  end
%  keyboard

% % 
% %   StructConst
% %   AdjRepTrans
% 
%   priv_testadjointrepresentation( rank, StructConst, AdjRepTrans);

%   for i = 1:N,
%     for j = 1:N,
%       [i,j]
%       Tmp = commutator( squeeze( AdjRepTrans(:,:,i)), squeeze( AdjRepTrans(:,:,j)));
%     end
%   end
%     %  AdjRepTrans = AdjRepTrans / N;
  
%  keyboard

end
